!c Description:
!c   ǥХå⡼. 
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2004-04-26    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2004, All rights reserved

program OboroDebug
  use prm_type, only: type_property
  use gtool_history
  use prm_common, only: obrinit, struct, property, emol_ini, &
       & smax, emax, pres_ini, pres_end, temp_ini, cnv, min, &
       & pseudosw, AdbtFile
  use interface_netcdf_open
  use interface_netcdf_get
  use interface_netcdf_close
  use interface_mingibbs_chk
  use interface_entropy
  use interface_packing
  use interface_molfraction
  use interface_name_cnd2gas
  
  implicit none
  real(8), allocatable        :: pres_map(:)      
  real(8), allocatable        :: entr_map(:)
  real(8), allocatable        :: temp_map(:)
  real, allocatable           :: temp(:)      
  real, allocatable           :: entr_all(:)
  real, allocatable           :: entr_err(:)
  real, allocatable           :: mol_plot(:,:)
  real, allocatable           :: presfr_plot(:,:)
  real, allocatable           :: entr_plot(:,:)
  real, allocatable           :: svap(:,:)
  real(8), allocatable        :: mol(:)
  real(8), allocatable        :: mol_map(:,:)
  real(8), allocatable        :: mol_tmp(:,:)
  real(8), allocatable        :: mol_store(:,:)
  real(8), allocatable        :: emol_map(:,:)
  real(8), allocatable        :: emol_tmp(:,:)
  real(8), allocatable        :: molfr(:)
  real(8), allocatable        :: molfr_store(:,:)
  real(8), allocatable        :: entr(:)
  real(8), allocatable        :: entr_store(:,:)
  real(8), parameter          :: temp_chg = -2.0d0
  real(8)                     :: temp_tmp(100)     
  real(8)                     :: entr_tmp(100)      
  real(8)                     :: entr_err_tmp(100) 
  real(8)                     :: err
  real(8)                     :: svap1
  real(8)                     :: pres_bs
  real(8)                     :: temp1, temp2, temp3  
  real(8)                     :: entr1, entr2, entr3  
  real                        :: temp_bs(2), entr_bs(2)
  integer                     :: i, l, s
  integer                     :: step
  integer                     :: ncid
  integer                     :: iws
  character(10)               :: name

  
!!!
!!!ǡƤӽФ
!!!
  call obrinit


!!!
!!!NetCDF եΥץ
!!! pres, spc, elm Ǥ뤳ȤΤäƤ
!!!
  !եΥץ
  call netcdf_open(trim(AdbtFile), ncid)

  !ѿμ. Фѿ pres, spc, elm, temp, mol, molfr 
  name = 'pres'
  call netcdf_get(ncid, name, pres_map)
  name = 'temp'
  call netcdf_get(ncid, name, temp_map)
  name = 'entr'
  call netcdf_get(ncid, name, entr_map)
  name = 'mol'
  call netcdf_get(ncid, name, mol_tmp)
  name = 'emol'
  call netcdf_get(ncid, name, emol_tmp) 
  
  !γ
  step = size(pres_map)
  allocate(mol_map(step, smax), &
       & emol_map(step, emax), mol(smax), mol_store(100,smax), &
       & molfr(smax), molfr_store(100, smax), &
       & entr(smax), entr_store(100, smax))
  mol_map   = transpose(mol_tmp)
  emol_map  = transpose(emol_tmp)
  temp = 0.0d0
  mol = 0.0d0; mol_store = 0.0d0
  molfr = 0.0d0; molfr_store = 0.0d0
  entr = 0.0d0; entr_store = 0.0d0
  
  !եĤ
  call netcdf_close(ncid)
  

!!!
!!!֥ǾˡԤνͤ
!!!
  write(*,*) "ϤϤƲ (ƥå׿)"
!  read(*,*) pres_bs
  read(*,*) l

  !Ϥ줿Ϥ˶ᤤʻ
!  l = minloc(pres_map, 1, pres_map > pres_bs)
  write(*,*) "ΰϤ˴ؤƷ׻ޤ: ", pres_map(l)


!!!
!!!֥ͳͥ륮Ǿ
!!!

  !ƥå1: ȥԡͤ򶴤ಹ٤
  i = 0
  STEP1: do 
     !
     temp3 = (temp_map(l - 1) + 5.0d0) + i * temp_chg
     
     !ȥԡη׻
     call mingibbs_chk(temp3, pres_map(l), &
          & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
     call entropy(temp3, pres_map(l), mol, property, &
          & entr_all = entr3, entr = entr)
     call molfraction(mol, property%phase, molfr)

     !«Υå
     err = abs(entr3 - entr_map(l-1))/entr_map(l-1)
     temp_tmp(i) = temp3
     entr_tmp(i) = entr3
     entr_err_tmp(i) = err
     mol_store(i,:) = mol(:)
     molfr_store(i,:) = molfr(:)
     entr_store(i,:) = entr(:)

     !롼׽λ
     if (entr3 < entr_map(l-1)) then 
        exit STEP1
     end if
     
     !롼פ֤
     i = i + 1
     entr1 = entr3
     temp1 = temp3
  end do STEP1

  !ƥå 2: ٤ǤΥȥԡ, 1 ƥåǤ
  !            ȥԡƱˤʤޤǼ«.
!  i = 1
  STEP2: do 
     !Ǥͤ׻
     temp2 = (temp1 + temp3) / 2.0d0

     write(*,*) "****************************************************"
     call mingibbs_chk(temp2, pres_map(l), &
          & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
     call entropy(temp2, pres_map(l), &
          & mol, property, entr_all=entr2, entr=entr)
     call molfraction(mol, property%phase, molfr)
     
     !«Υå
     err = abs(entr2 - entr_map(l-1))/entr_map(l-1)
     temp_tmp(i) = temp2
     entr_tmp(i) = entr2
     entr_err_tmp(i) = err
     mol_store(i,:) = mol(:)
     molfr_store(i,:) = molfr(:)
     entr_store(i,:) = entr(:)
     
     !롼׽λ. 
     if (abs((entr2 - entr_map(l-1))/entr_map(l-1)) <= cnv) then
        write(*,*) "(", l, ") ", "Entropy is now converged" 
        exit STEP2
     end if
     
     !Ū˲٤ˤϥå. 
     if (temp1 == temp2 .OR. temp2 == temp3) then
        write(*,*) temp1, temp2, temp3
        write(*,*) "Conserved Entropy is slightly changed", &
             & entr_map(l-1), " -> ", entr2
        write(*,*) "(", l, ") ", "Entropy is now converged" 

        exit STEP2
     end if
     
     !ƥåפʤ뤿ν
     if (entr3 < entr_map(l-1) .and. entr_map(l-1) < entr2) then
        temp1 = temp2
        entr1 = entr2
     elseif (entr2 <= entr_map(l-1) .and. entr_map(l-1) < entr1) then
        temp3 = temp2
        entr3 = entr2
     end if

     i = i + 1
  end do STEP2
  
!!!
!!!ץåȤ뤿
!!!
  step = minloc(temp_tmp, 1, temp_tmp == 0.0d0) -1
  write(*,*) step

  allocate(temp(step), entr_all(step), entr_err(step), &
       & mol_plot(step,smax), presfr_plot(step,smax), &
       & svap(step,smax), entr_plot(step,smax))
  temp = 0.0d0; entr_all = 0.0d0; entr_err = 0.0d0; molfr = 0.0d0
  entr_plot = 0.0d0

  temp = real(temp_tmp(1:step), 4)
  entr_all = real(entr_tmp(1:step), 4)
  entr_err = real(entr_err_tmp(1:step), 4)
  mol_plot(:,:) = real(mol_store(1:step,:), 4)
  presfr_plot(:,:) = real(molfr_store(1:step,:)*pres_map(l), 4)
  entr_plot(:,:) = real(entr_store(1:step,:), 4)
  
  entr_bs = entr_map(l-1)
  temp_bs(1) = minval(temp)
  temp_bs(2) = maxval(temp)

!!!
!!!˰¾
!!!
  do i = 1, step
     PLOT: do s = 1, smax
        if (property(s)%method == 3) then 
           call svap_amp(temp_tmp(i), property(s)%svap_cef, svap1)
        elseif (property(s)%method == 4) then 
           call svap_antoine(temp_tmp(i), property(s)%svap_cef, svap1)
        else
           cycle plot
        end if
        
        svap(i,s) = real(svap1, 4) 
     end do PLOT
  end do



  
!!!
!!!ͤɽ
!!!
  !դΥץ
  write(*,*) "workstation ID (i) ?"
  call sgpwsn
  read(*,*) iws
!  call sglset('LCORNER', .FALSE.)
!  call swiset('IWIDTH', 600)
!  call swiset('IHEIGHT', 600)
  call gropn(iws)
  CALL SLDIV( 'Y', 3, 2 ) 
!  call slmgn(0.05, 0.05, 0.01, 0.01)

  !պ
  call grfrm
  call usspnt(step, temp, entr_all)
  call usspnt(2, temp_bs, entr_bs)

  call grstrn(1)
  call uspfit
  call grstrf
  call ussttl('Temperature', 'K', 'entropy', 'J/K')
  call usdaxs
  
  call uusmkt(5)
  call uusmki(3)
  call uumrk(step, temp, entr_all)  
  call sgspli(21)
  call sgplu(2, temp_bs, entr_bs)
  call uxsttl('T', 'entropy', 0.0)
  
  !պ
  call grfrm
  call usspnt(step, temp, entr_err)

  call grstrn(2)
  call uspfit
  call grstrf
  call ussttl('Temperature', 'K', 'entropy', 'J/K')
  call usdaxs
  
  call uusmkt(5)
  call uusmki(3)
  call uumrk(step, temp, entr_err)
  call uxsttl('T', 'entropy error', 0.0)
  

  !
  do i = 1, smax
     call grfrm
     call usspnt(step, temp, mol_plot(:,i))

     call grstrn(1)
     call uspfit
     call grstrf
     call ussttl('Temperature', 'K', 'mol', 'mol')
     call usdaxs
     
     call uusmkt(5)
     call uusmki(3)
     call uumrk(step, temp, mol_plot(:,i))
     call uxsttl('T', property(i)%name, 0.0)
  end do
  
  !ʬ. ˰¾˥ץå
  do i = 1, count(property%phase == 1)
     call grfrm
     call usspnt(step, temp, presfr_plot(:,i))
     do s = count(property%phase == 1) + 1, smax
        call name_cnd2gas(property(s)%name, name)
        if (trim(name) /= trim(property(i)%name)) cycle
        call usspnt(step, temp, svap(:,s))
     end do

     call grstrn(2)
     call uspfit
     call grstrf
     call ussttl('Temperature', 'K', 'molfr', '')
     call usdaxs
     
     call uusmkt(5)
     call uusmki(3)
     call uumrk(step, temp, presfr_plot(:,i))
     do s = count(property%phase == 1) + 1, smax
        call name_cnd2gas(property(s)%name, name)
        if (trim(name) /= trim(property(i)%name)) cycle
        l = s * 10 + 5
        call sgspli(l)
        call sgplu(step, temp, svap(:,s))
     end do
     call uxsttl('T', property(i)%name, 0.0)
  end do

  !ȥԡΥץå
  do i = 1, smax
     call grfrm
     call usspnt(step, temp, entr_plot(:,i))
     
     call grstrn(1)
     call uspfit
     call grstrf
     call ussttl('Temperature', 'K', 'entropy', 'J/K')
     call usdaxs
     
     call uusmkt(5)
     call uusmki(3)
     call uumrk(step, temp, entr_plot(:,i))
     call uxsttl('T', property(i)%name, 0.0)
  end do

  !դΥ
  call grcls


end program OboroDebug



