!c Description:
!c   Antoine ηиˤ˰¾, ˰¾ 1 , 2 ʬ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-20    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_svap_antoine
  interface

     subroutine svap_antoine(temp, svap_cef, svap, svap_dt, svap_2dt)  
       use prm_type, only: type_svap
       real(8), intent(in)            :: temp     !
       real(8), intent(out)           :: svap     !˰¾
       real(8), intent(out), optional :: svap_dt  !˰¾βʬ
       real(8), intent(out), optional :: svap_2dt !˰¾β٤2ʬ
       type(type_svap), intent(in)    :: svap_cef !˰¾η
     end subroutine svap_antoine

  end interface
end module interface_svap_antoine



subroutine svap_antoine(temp, svap_cef, svap, svap_dt, svap_2dt)  
  use prm_phys, only: gasr
  use prm_type, only: type_svap
  
  implicit none
  real(8), intent(in)            :: temp         !
  real(8), intent(out)           :: svap         !˰¾
  real(8), intent(out), optional :: svap_dt      !˰¾βʬ
  real(8), intent(out), optional :: svap_2dt     !˰¾β٤2ʬ
  type(type_svap), intent(in)    :: svap_cef     !˰¾η

  real(8)                        :: svap_log     !˰¾ log
  real(8)                        :: svap_log_dt  !˰¾ log βʬ
  real(8)                        :: svap_log_2dt !˰¾log2ʬ

!!!
!!!Antoine μ
!!!
  svap_log = (svap_cef%A &
       & - (svap_cef%B / (svap_cef%C + temp - 273.15D0))) &
       & * dlog(10.0D0) + dlog(133.322D0)
  
  svap_log_dt =  svap_cef%B * dlog(10.0D0) &
       & / (svap_cef%C + temp - 273.15D0)**2.0D0 
  
  svap_log_2dt = - 2.0D0 * svap_cef%B * dlog(10.0D0) &
       & / (svap_cef%C + temp - 273.15D0)**3.0D0 
  
  svap = dexp(svap_log)
  if (present(svap_dt)) svap_dt = dexp(svap_log_dt)
  if (present(svap_2dt)) svap_2dt = dexp(svap_log_2dt)
  
  
end subroutine svap_antoine

