!c Description:
!c  
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-07    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module prm_common
  use prm_type, only: type_property
  use prm_file, only: InputFile

  implicit none
  save
  real(8)                           :: temp_ini    !
  real(8)                           :: pres_ini    !
  real(8)                           :: pres_end    !׻λ
  real(8)                           :: temp_map_ini!
  real(8)                           :: temp_map_end!
  real(8)                           :: pres_map_ini!
  real(8)                           :: pres_map_end!׻λ
  real(8)                           :: grav        !
  real(8)                           :: min         !Ǿ
  real(8)                           :: int         !
  real(8)                           :: cnv         !Ǿи
  real(8)                           :: zero        !Ǿ
  real(8), allocatable              :: struct(:,:) !¤η
  real(8), allocatable              :: emol_ini(:) !ǤΥ
  integer                           :: step        !׻Υƥå׿
  integer                           :: smax        !ؼο
  integer                           :: emax        !ؼο
  integer, allocatable              :: atmnum(:)   !ֹ
  character(10)                     :: planet      !̾
  character(80)                     :: PropertyDir !ʪǡե־
  character(80)                     :: MapFile     !ȥץåȥե
  character(80)                     :: AdbtFile    !ȥץåȥե
  character(80)                     :: AtmosFile   !ȥץåȥե
  logical                           :: pseudosw    !Υå
  logical                           :: debug
  type(type_property), allocatable  :: property(:) !ʪ

contains
  subroutine obrinit
    use interface_def_gravity
    use interface_def_property
    use interface_def_atmnum
    use interface_def_phase
    use interface_def_struct
    use interface_mol2emol
    use interface_def_cp_cef
    use interface_def_svap_cef

    implicit none
    character(10)            :: sname(100)     !ʪ̾
    real(8)                  :: mol_ini(100)   !
    integer                  :: l

    NAMELIST /ControlData/ &
         & min, cnv, zero, debug, PropertyDir
    NAMELIST /AdbtData/ &
         & temp_ini, pres_ini, pres_end, &
         & step, pseudosw, AdbtFile
    NAMELIST /AtmosData/ &
         & planet, AtmosFile
    NAMELIST /MapData/ &
         & temp_map_ini, temp_map_end, pres_map_ini, pres_map_end, MapFile
    NAMELIST /Moles/ mol_ini
    NAMELIST /Names/ sname
    

!!!
!!!Namelist ե뤫ѿФ
!!!    
    open (10, FILE=InputFile)
    read(10, NML=ControlData)
    close(10)
    
    open (10, FILE=InputFile)
    read(10, NML=AtmosData)
    close(10)
    
    open (10, FILE=InputFile)
    read(10, NML=AdbtData)
    close(10)
    
    open (10, FILE=InputFile)
    read(10, NML=MapData)
    close(10)
    
    mol_ini = -1.0d0
    open (10, FILE=InputFile)
    read(10, NML=Moles)
    close(10)   
    
    open (10, FILE=InputFile)
    read(10, NML=Names)
    close(10)   
    
!!!
!!!Ϥͤ
!!!
    call def_gravity(planet, grav)

!!!
!!!ʪͤ
!!!
    smax = count(mol_ini /= -1.0)
    call def_property(sname(1:smax), propertydir, property)
    
!!!
!!!ʪֹ̤򿶤
!!!
    property%num = (/(l, l = 1, size(property, 1))/)
    
!!!
!!!ֹڤӸǿ
!!!
    call def_atmnum(property, atmnum)
    emax = size(atmnum, 1)

!!!
!!!ֹƤ. 
!!!  Τ 1, ϱդ 2, Τ 3, ʳ 4
!!!
    call def_phase(property)

!!!
!!!¤η
!!!
    call def_struct(property, struct)

!!!
!!!ǤΥ
!!!
    call mol2emol(mol_ini, struct, emol_ini)

!!!
!!!ǮΥץ饤ַ
!!!
    call def_cp_cef(property)

!!!
!!!˰¾η
!!!
    call def_svap_cef(property, propertydir)


  end subroutine obrinit
end module prm_common
